program NkVp;

uses
  Windows, Messages, SysUtils, ShellAPI, ActiveX,
  VideoPlayer,
  SForm, KeyTable, ConfFile;

{$R *.res}

const
  AppName = 'NkVp';
  Version = '0.2 (2003-04-20)';
  Copyright = 'Copyright (C) 2003 Nobuyuki Honda (Ferdia)'#13#10+
    #13#10+
    'This software is free software.'#13#10+
    'Freely redistributable. Absolutely no warranty.'#13#10;

  IDM_PAUSE         = 100;
  IDM_STOP          = 101;
  IDM_SEEKFORWARD   = 110;
  IDM_SEEKBACK      = 111;
  IDM_ASPECT43      = 112;
  IDM_MUTE          = 113;
  IDM_FIT           = 114;
  IDM_STAYONTOP     = 115;
  IDM_FULLSCREEN    = 116;
  IDM_ASPECTORG     = 117;
  IDM_ABOUT         = 198;
  IDM_EXIT          = 199;
  IDM_ZOOMSTART     = 1000;
  IDM_ZOOMEND       = 1999;
  IDM_ZOOM50        = 1050;
  IDM_ZOOM100       = 1100;
  IDM_ZOOM150       = 1150;
  IDM_ZOOM200       = 1200;
  IDM_ZOOM300       = 1300;
  IDM_ZOOM400       = 1400;

  Cmds: array[0..16] of TCmd = (
    (Name: 'Pause'; Caption: '&Play / Pause'; Id: IDM_PAUSE),
    (Name: 'Stop'; Caption: '&Stop'; Id: IDM_STOP),
    (Name: 'Mute'; Caption: '&Mute'; Id: IDM_MUTE),
    (Name: 'FullScreen'; Caption: 'Full &Screen'; Id: IDM_FULLSCREEN),
    (Name: 'StayOnTop'; Caption: 'Stay &On Top'; Id: IDM_STAYONTOP),
    (Name: 'Zoom50'; Caption: 'Zoom &50%'; Id: IDM_ZOOM50),
    (Name: 'Zoom100'; Caption: 'Zoom &100%'; Id: IDM_ZOOM100),
    (Name: 'Zoom150'; Caption: 'Zoom 150%(&Q)'; Id: IDM_ZOOM150),
    (Name: 'Zoom200'; Caption: 'Zoom &200%'; Id: IDM_ZOOM200),
    (Name: 'Zoom300'; Caption: 'Zoom &300%'; Id: IDM_ZOOM300),
    (Name: 'Zoom400'; Caption: 'Zoom &400%'; Id: IDM_ZOOM400),
    (Name: 'SeekForward'; Caption: 'Seek Forward'; Id: IDM_SEEKFORWARD),
    (Name: 'SeekBack'; Caption: 'Seek Back'; Id: IDM_SEEKBACK),
    (Name: 'Aspect43'; Caption: 'Set Aspect 4:3'; Id: IDM_ASPECT43),
    (Name: 'AspectOrg'; Caption: 'Set Original Aspect'; Id: IDM_ASPECTORG),
    (Name: 'About'; Caption: '&About'; Id: IDM_ABOUT),
    (Name: 'Exit'; Caption: 'E&xit'; Id: IDM_EXIT)
  );

  DefaultKeys: array[0..39] of string = (
    'Enter', 'FullScreen',
    'Esc',   'Stop',
    'Space', 'Pause',
    'Left',  'SeekBack',
    'Right', 'SeekForward',
    'Num1',  'Zoom100',
    'Num2',  'Zoom200',
    'Num3',  'Zoom300',
    'Num4',  'Zoom400',
    'Num5',  'Zoom50',
    '1',     'Zoom100',
    '2',     'Zoom200',
    '3',     'Zoom300',
    '4',     'Zoom400',
    '5',     'Zoom50',
    'A',     'Aspect43',
    'M',     'Mute',
    'Q',     'Zoom150',
    'S',     'AspectOrg',
    'T',     'StayOnTop'
  );

  MenuTable: array[0..15] of Integer = (
    IDM_PAUSE,
    IDM_STOP,
    IDM_MUTE,
    -1,
    IDM_ZOOM50,
    IDM_ZOOM100,
    IDM_ZOOM150,
    IDM_ZOOM200,
    IDM_ZOOM300,
    IDM_ZOOM400,
    -1,
    IDM_FULLSCREEN,
    IDM_STAYONTOP,
    -1,
    IDM_ABOUT,
    IDM_EXIT
  );

  KeyMapFile = 'keymap';

  StatBarHeight = 13;
  WheelSeek = 1000; // zC[gpseek(msec)
  ZoomTable: array [0..8] of Integer =
    (25, 50, 66, 100, 125, 150, 200, 300, 400);

type
  TMainWindow = class(TSForm)
    FFullScreen: Boolean;
    SaveWP: TWindowPlacement;
    SaveWS: Integer;
    SaveStayOnTop: Boolean;
    ModeStr: string;
    TimeStr: string;
    FormatStr: string;
    ScreenAspect: Double;
    Zoom: Integer;
    DispWidth: Integer;
    DispHeight: Integer;
    Mute: Boolean;
    SaveMode: TVPModes;
    procedure SetFullScreen(Value: Boolean);
    property FullScreen: Boolean read FFullScreen write SetFullScreen;
    procedure SetTitle;
    procedure SetFormatStr;
    procedure FitWindow;
    procedure ZoomVideo(Value: Integer);
    procedure ShowAbout;
    procedure PopupMenu;
    procedure DrawStatusBar(dc: HDC; rc: TRect);
    procedure OnTimer;
    procedure OnDropFiles(hDrop: THandle);
    procedure OnCommand(Id: Integer);
    procedure WndProc(var Message: TMessage); override;
  end;

var
  MainWindow: TMainWindow;
  Video: TVideoPlayer;
  KeyTbl: TKeyTable;
  MsgMouseWheel: Integer;
  ProfDir: string;

function GetTimeStr(n: Integer): string;
var
  t: Integer;
  v: array[0..2] of Integer;
begin
  SetLength(Result, 8);
  t := n div 1000;
  v[0] := t div 3600;
  v[1] := t mod 3600 div 60;
  v[2] := t mod 60;
  wvsprintf(PChar(Result), '%02d:%02d:%02d', @v);
end;

procedure TMainWindow.SetFullScreen(Value: Boolean);
begin
  FFullScreen := Value;
  if FFullScreen then
  begin
    SaveStayOnTop := StayOnTop;
    StayOnTop := True;
    FillChar(savewp, SizeOf(savewp), 0);
    SaveWP.length := SizeOf(savewp);
    GetWindowPlacement(Handle, @savewp);
    SaveWS := GetWindowLong(Handle, GWL_STYLE);
    SetWindowLong(Handle, GWL_STYLE, WS_OVERLAPPEDWINDOW
      and not WS_CAPTION and not WS_THICKFRAME and not WS_SYSMENU);
    ShowWindow(Handle, SW_SHOWNA);
    MoveWindow(Handle, 0, 0, GetSystemMetrics(SM_CXSCREEN),
      GetSystemMetrics(SM_CYSCREEN), True);
    //ShowWindow(hWnd, SW_SHOWMAXIMIZED);
  end
  else begin
    SetWindowLong(Handle, GWL_STYLE, SaveWS and not WS_MAXIMIZE);
    ShowWindow(Handle, SW_SHOWNA);
    SetWindowPlacement(Handle, @SaveWP);
    StayOnTop := SaveStayOnTop;
  end;
end;

procedure TMainWindow.ShowAbout;
const
  mi: PWideChar = 'MAINICON';
var
  mbp: TMsgBoxParams;
  osv: TOsVersionInfo;
begin
  FillChar(osv, SizeOf(osv), 0);
  osv.dwOSVersionInfoSize := SizeOf(TOsVersionInfo);
  GetVersionEx(osv);
  FillChar(mbp, SizeOf(mbp), 0);
  with mbp do begin
    cbSize      := SizeOf(mbp);
    hwndOwner   := Handle;
    hInstance   := MainInstance;
    lpszText    := PChar(AppName+' '+Version+#13#10#13#10+Copyright+#13#10+'Profile Folder: '+ProfDir);
    lpszCaption := 'About '+AppName;
    dwStyle     := MB_USERICON;
    // NTłWideCharœnȂƂ(ANSI version APIȂ̂Ɂc)
    case osv.dwPlatformId of
      VER_PLATFORM_WIN32_WINDOWS: lpszIcon := 'MAINICON';
      VER_PLATFORM_WIN32_NT:      lpszIcon := Pointer(mi);
    end;
  end;
  MessageBoxIndirect(mbp);
end;

procedure TMainWindow.FitWindow;
var
  rc, wrc: TRect;
  w, h: Integer;
begin
  if IsZoomed(Handle) then ShowWindow(Handle, SW_RESTORE);
  w := Video.Width;
  h := Video.Height;
  if ScreenAspect > 0 then
    w := Trunc(h / ScreenAspect);
  if w = 0 then
    w := 320;
  rc.Left := 0;
  rc.Top := 0;
  rc.Right := (w * Zoom) div 100;
  rc.Bottom := (h * Zoom) div 100;
  wrc := rc;
  AdjustWindowRect(wrc, GetWindowLong(Handle, GWL_STYLE), False);
  with wrc do
    SetSize(Right-Left, Bottom-Top+StatBarHeight);
  if Video.Loaded then
    Video.SetWindowPosition(rc.left, rc.top, rc.right, rc.bottom);
end;

procedure TMainWindow.SetFormatStr;
var
  s: string;
begin
  case Video.WaveFormat.wFormatTag of
    1: FormatStr := 'PCM ';
    2: FormatStr := 'MSADPCM ';
    85: FormatStr := 'MP3 ';
  else
    FormatStr := '';
  end;
  if Video.WaveFormat.nChannels = 2 then
    s := 'st '
  else
    s := '';
  FormatStr := FormatStr +
    IntToStr(Video.WaveFormat.nSamplesPerSec div 1000)+'kHz '+
    IntToStr(Video.WaveFormat.nAvgBytesPerSec*8 div 1000) + 'k ' + s +
    Copy(PChar(@Video.BitmapInfoHeader.biCompression), 1, 4) + ' ';
end;

procedure TMainWindow.SetTitle;
var
  s: string;
  ss: string;
begin
  with Video do
  begin
    Str(Fps :0:3, ss);
    s := ExtractFileName(FileName)+' ('+IntToStr(Width)+'x'+IntToStr(Height)+
      ' '+ss+'fps) '+IntToStr(Zoom)+'% - '+AppName;
    SetWindowText(Handle, PChar(s));
  end;
end;

procedure TMainWindow.OnTimer;
var
  rc: TRect;
begin
  TimeStr := FormatStr + GetTimeStr(Video.Position) + ' / ' + GetTimeStr(Video.Length) + ' ';
  case Video.Mode of
    vpPause: ModeStr := ' PAUSE ';
    vpStop:  ModeStr := ' STOP ';
  else
    ModeStr := ' ';
  end;
  if Mute then
    ModeStr := ModeStr + 'MUTE';
  rc := ClientRect;
  rc.Top := rc.Bottom - StatBarHeight;
  InvalidateRect(Handle, @rc, False);
end;

procedure TMainWindow.OnDropFiles(hDrop: THandle);
var
  FileName: string;
begin
  SetLength(FileName, DragQueryFile(hDrop, 0, nil, 0)+1);
  DragQueryFile(hDrop, 0, PChar(FileName), Length(FileName));
  DragFinish(hDrop);
  Video.LoadFile(PChar(FileName));
  if Video.Loaded then
  begin
    ScreenAspect := 0;
    SetTitle;
    SetFormatStr;
    FitWindow;
    Video.Play;
  end;
end;

procedure TMainWindow.DrawStatusBar(dc: HDC; rc: TRect);
var
  src, rc2: TRect;
  bbr, gbr: HBRUSH;
  font: HFONT;
  mdc: HDC;
  bmp, oldbmp: HBITMAP;
begin
  {
  //FillRect(dc, rc, GetStockObject(BLACK_BRUSH));
  SetTextColor(dc, RGB(0, 255, 255));
  SetBkMode(dc, TRANSPARENT);
  DrawText(dc, PChar(TimeStr), Length(TimeStr), rc, DT_RIGHT or DT_SINGLELINE or DT_VCENTER);
  Exit;
  }

  src.Left := 0;
  src.Top := 0;
  src.Right :=  rc.Right - rc.Left;
  src.Bottom := rc.Bottom - rc.Top;
  mdc := CreateCompatibleDC(dc);
  bmp := CreateCompatibleBitmap(dc, src.Right, src.Bottom);
  oldbmp := SelectObject(mdc, bmp);

  bbr := GetStockObject(BLACK_BRUSH);
  gbr := GetStockObject(GRAY_BRUSH);
  FrameRect(mdc, src, gbr);
  Inc(src.Top);
  FillRect(mdc, src, bbr);
  if Video.Loaded and (Video.Length > 0) then
    rc2.Left := Trunc(Video.Position / Video.Length * rc.Right) - 2
  else
    rc2.Left := -2;
  rc2.Right := rc2.Left + 4 + 1;
  rc2.Top := 2;
  rc2.Bottom := src.Bottom - 1;
  FillRect(mdc, rc2, gbr);
  Inc(rc2.Left ,2);
  rc2.Right := rc2.Left + 1;
  rc2.Bottom := rc2.Top + 2;
  FillRect(mdc, rc2, bbr);
  rc2.Bottom := src.Bottom - 1;
  rc2.Top := rc2.Bottom - 2;
  FillRect(mdc, rc2, bbr);
  SetTextColor(mdc, RGB(0, 255, 255));
  SetBkMode(mdc, TRANSPARENT);
  font := SelectObject(mdc, GetStockObject(DEFAULT_GUI_FONT));
  DrawText(mdc, PChar(ModeStr), Length(ModeStr), src, DT_SINGLELINE or DT_VCENTER);
  DrawText(mdc, PChar(TimeStr), Length(TimeStr), src, DT_RIGHT or DT_SINGLELINE or DT_VCENTER);
  SelectObject(mdc, font);
  BitBlt(dc, rc.Left, rc.Top, rc.Right, rc.Bottom, mdc, 0, 0, SRCCOPY);
  SelectObject(mdc, oldbmp);
  DeleteObject(bmp);
  DeleteDC(mdc);
end;

procedure TMainWindow.ZoomVideo(Value: Integer);
begin
  if FullScreen then
    OnCommand(IDM_FULLSCREEN);
  Zoom := Value;
  OnTimer;
  FitWindow;
  SetTitle;
end;

procedure TMainWindow.OnCommand(Id: Integer);
begin
  case Id of
    IDM_PAUSE: if Video.Mode = vpStop then Video.Play else Video.Pause;
    IDM_STOP:  Video.Stop;
    IDM_ZOOMSTART..IDM_ZOOMEND:
      ZoomVideo(Id - IDM_ZOOMSTART);
    IDM_FIT:
      FitWindow;
    IDM_STAYONTOP:
      StayOnTop := not StayOnTop;
    IDM_FULLSCREEN:
      FullScreen := not FullScreen;
    IDM_MUTE:
      begin
        Mute := not Mute;
        if Mute then
          Video.Volume := -10000
        else
          Video.Volume := 0;
      end;
    IDM_SEEKFORWARD:
      begin
        Video.Position := Video.Position + WheelSeek;
        OnTimer;
      end;
    IDM_SEEKBACK:
      begin
        Video.Position := Video.Position - WheelSeek;
        OnTimer;
      end;
    IDM_ASPECT43:
      begin
        ScreenAspect := 0.75;
        SendMessage(Handle, WM_SIZE, 0, 0);
      end;
    IDM_ASPECTORG:
      begin
        ScreenAspect := 0;
        SendMessage(Handle, WM_SIZE, 0, 0);
      end;
    IDM_ABOUT:
      ShowAbout;
    IDM_EXIT:
      Close;
  end;
  OnTimer;
end;

procedure TMainWindow.PopupMenu;
  function Checked(flg: Boolean): Integer;
  begin
    if flg then Result := MF_CHECKED else Result := MF_UNCHECKED;
  end;
var
  pt: TPoint;
  Menu: HMENU;
begin
  Menu := CreatePopupMenu;
  KeyTbl.MenuHandle := Menu;
  KeyTbl.GenerateMenu(MenuTable);

  if not Video.Loaded then
  begin
    EnableMenuItem(Menu, IDM_PAUSE, MF_GRAYED);
    EnableMenuItem(Menu, IDM_STOP, MF_GRAYED);
    EnableMenuItem(Menu, IDM_MUTE, MF_GRAYED);
    EnableMenuItem(Menu, IDM_FIT, MF_GRAYED);
    EnableMenuItem(Menu, IDM_FULLSCREEN, MF_GRAYED);
    EnableMenuItem(Menu, IDM_ZOOM50, MF_GRAYED);
    EnableMenuItem(Menu, IDM_ZOOM100, MF_GRAYED);
    EnableMenuItem(Menu, IDM_ZOOM150, MF_GRAYED);
    EnableMenuItem(Menu, IDM_ZOOM200, MF_GRAYED);
    EnableMenuItem(Menu, IDM_ZOOM300, MF_GRAYED);
    EnableMenuItem(Menu, IDM_ZOOM400, MF_GRAYED);
  end;
  CheckMenuItem(Menu, IDM_FULLSCREEN, Checked(FullScreen));
  CheckMenuItem(Menu, IDM_STAYONTOP, Checked(StayOnTop));
  CheckMenuItem(Menu, IDM_MUTE, Checked(Mute));
  if FullScreen then
    EnableMenuItem(Menu, IDM_STAYONTOP, MF_GRAYED);
  GetCursorPos(pt);
  TrackPopupMenu(Menu, TPM_LEFTALIGN or TPM_LEFTBUTTON or TPM_RIGHTBUTTON,
    pt.x, pt.y, 0, Handle, nil);
  DestroyMenu(Menu);
end;

procedure TMainWindow.WndProc(var Message: TMessage);
var
  rc: TRect;
  ps: TPaintStruct;
  dc: HDC;
  w, h : Integer;
  pt: TPoint;
begin
  with Message do
  begin
    Result := 0;
    if (Msg = WM_MOUSEWHEEL) or ((Msg = MsgMouseWheel) and (MsgMouseWheel <> 0)) then
    begin
      if wParam > 0 then
        Video.Position := Video.Position - WheelSeek
      else
        Video.Position := Video.Position + WheelSeek;
      OnTimer;
      Exit;
    end;
    case Msg of
      WM_GETMINMAXINFO:
        with PMinMaxInfo(lParam)^ do
        begin
          ptMaxTrackSize.x := 4096;
          ptMaxTrackSize.y := 4096;
        end;
      WM_DROPFILES:
        OnDropFiles(wParam);
      WM_COMMAND:
        OnCommand(LoWord(wParam));
      WM_PAINT:
        begin
          dc := BeginPaint(Handle, ps);
          rc := ClientRect;
          //if not Video.Loaded then
          //  FillRect(dc, rc, GetStockObject(BLACK_BRUSH));
          rc.Top := rc.Bottom - StatBarHeight;
          DrawStatusBar(dc, rc);
          EndPaint(Handle, ps);
        end;
      WM_RBUTTONUP:
        PopupMenu;
      WM_MBUTTONUP:
        begin
          Video.Stop;
          OnTimer;
        end;
      WM_MOUSEMOVE:
        if GetCapture = Handle then
        begin
          GetCursorPos(pt);
          ScreenToClient(Handle, pt);
          rc := ClientRect;
          Video.Position := Trunc(pt.x / rc.Right * Video.Length);
          OnTimer;
        end;
      WM_LBUTTONDOWN,
      WM_LBUTTONDBLCLK:
        begin
          rc := ClientRect;
          if HIWORD(LParam) < (rc.Bottom - StatBarHeight) then
          begin
            if Video.Mode = vpStop then
              Video.Play
            else
              Video.Pause;
          end
          else begin
            SetCapture(Handle);
            SaveMode := Video.Mode;
            Video.PauseOnly;
            Video.Position := Trunc(LOWORD(LParam) / rc.Right * Video.Length);
            //if Video.Mode = vpStop then Video.Play;
          end;
          OnTimer;
        end;
      WM_LBUTTONUP:
        if GetCapture = Handle then
        begin
          ReleaseCapture;
          if SaveMode = vpPlay then
            Video.Play;
        end;
      WM_SIZE:
        if Video.Loaded then
        begin
          rc := ClientRect;
          Dec(rc.bottom, StatBarHeight);
          w := Video.Width;
          h := Video.Height;
          if (w = 0) and (h = 0) then
            Exit;
          if ScreenAspect > 0 then
            w := Trunc(h / ScreenAspect);
          if w*rc.Bottom > h*rc.Right then
          begin
            DispWidth := rc.Right;
            DispHeight := (h * DispWidth) div w;
          end
          else begin
            DispHeight := rc.Bottom;
            DispWidth := (w * DispHeight) div h;
          end;
          if DispHeight > DispWidth then
            Zoom := (DispWidth * 100) div w
          else
            Zoom := (DispHeight * 100) div h;
          Video.SetWindowPosition((rc.Right-DispWidth) div 2,
            (rc.Bottom-DispHeight) div 2, DispWidth, DispHeight);
          SetTitle;
        end;
      WM_CLOSE:
        begin
          Video.PauseOnly;
          Video.FreeInterface;
          DestroyWindow(Handle);
        end;
      WM_DESTROY:
        PostQuitMessage(0);
    else
      inherited;
    end;
  end;
end;

begin
  CoInitialize(nil);
  try
    MsgMouseWheel := RegisterWindowMessage('MSWHEEL_ROLLMSG'); // for Win95
    ProfDir := GetProfDir('nkvp');

    MainWindow := TMainWindow.Create(AppName);
    with MainWindow do
    begin
      Zoom := 100;
      ClassStyle := CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS;
      Style := WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN;
      ExStyle := WS_EX_ACCEPTFILES;
      Brush := GetStockObject(BLACK_BRUSH);
      CreateWnd(CW_USEDEFAULT, CW_USEDEFAULT, 320, 240);
      if Handle = 0 then
         Halt(255);

      Video := TVideoPlayer.Create;
      Video.OnTimer := OnTimer;
      KeyTbl := TKeyTable.Create(Cmds, DefaultKeys, ProfDir + KeyMapFile);

      Show;
      Video.DisplayWnd := Handle;
      if ParamCount > 0 then
      begin
        Video.LoadFile(ParamStr(1));
        if Video.Loaded then
        begin
          ScreenAspect := 0;
          FitWindow;
          SetTitle;
          SetFormatStr;
          Video.Play;
        end;
      end;
      OnTimer;

      MessageLoopWithAccel(Handle, KeyTbl.AccHandle, ExitCode);

      KeyTbl.Free;
      Video.Free;
    end;
  finally
    CoUninitialize;
  end;
end.

